import { PostgrestHasMorePaginationResponse, PostgrestPaginationResponse, PostgrestHasMorePaginationCacheData, AnyPostgrestResponse } from '@supabase-cache-helpers/postgrest-shared';
export * from '@supabase-cache-helpers/postgrest-shared';
import * as _supabase_cache_helpers_postgrest_filter from '@supabase-cache-helpers/postgrest-filter';
import { PostgrestParser, PostgrestQueryParserOptions, PostgrestFilter } from '@supabase-cache-helpers/postgrest-filter';
export * from '@supabase-cache-helpers/postgrest-filter';
export * from '@supabase-cache-helpers/postgrest-fetcher';
import { DeleteItemProps, UpsertItemProps, DecodedKey, PostgrestMutatorOpts } from '@supabase-cache-helpers/postgrest-mutate';
import { PostgrestTransformBuilder, PostgrestQueryBuilder, PostgrestError as PostgrestError$1, PostgrestResponse, PostgrestSingleResponse, PostgrestMaybeSingleResponse } from '@supabase/postgrest-js';
import { GenericSchema, GenericTable } from '@supabase/postgrest-js/dist/module/types';
import { Key, Middleware, MutatorOptions, SWRResponse, SWRConfiguration } from 'swr';
import * as swr_infinite from 'swr/infinite';
import { SWRInfiniteHook, SWRInfiniteKeyLoader, SWRInfiniteFetcher, SWRInfiniteConfiguration, SWRInfiniteResponse } from 'swr/infinite';
import { GetResult } from '@supabase/postgrest-js/dist/module/select-query-parser';
import { PostgrestError, RealtimePostgresChangesPayload, SupabaseClient, RealtimePostgresChangesFilter, REALTIME_POSTGRES_CHANGES_LISTEN_EVENT, RealtimeChannel } from '@supabase/supabase-js';
export { PostgrestError } from '@supabase/supabase-js';
import { SWRMutationConfiguration, SWRMutationResponse } from 'swr/mutation';
export { SWRMutationConfiguration } from 'swr/mutation';

/**
 * Convenience hook to delete an item from the swr cache. Does not make any http requests, and is supposed to be used for custom cache updates.
 * @param opts The mutation options
 * @returns void
 */
declare function useDeleteItem<Type extends Record<string, unknown>>(opts: Omit<DeleteItemProps<Type>, 'input'>): (input: Type) => Promise<void>;

/**
 * Convenience hook to upsert an item into the swr cache. Does not make any http requests, and is supposed to be used for custom cache updates.
 * @param opts The mutation options
 * @returns void
 */
declare function useUpsertItem<Type extends Record<string, unknown>>(opts: Omit<UpsertItemProps<Type>, 'input'>): (input: Type) => Promise<void>;

declare const KEY_PREFIX = "postgrest";
declare const POSTGREST_FILTER_KEY_PREFIX = "postgrest-filter";
declare const KEY_SEPARATOR = "$";
declare const INFINITE_PREFIX = "$inf$";
declare const INFINITE_KEY_PREFIX = "page";

declare const createKeyGetter: <Schema extends GenericSchema, Table extends Record<string, unknown>, Result>(query: PostgrestTransformBuilder<Schema, Table, Result> | null, pageSize: number) => (pageIndex: number, previousPageData: (PostgrestHasMorePaginationResponse<Result> | PostgrestPaginationResponse<Result>)[]) => PostgrestTransformBuilder<Schema, Table, Result> | null;

type DecodedSWRKey = DecodedKey & {
    isInfinite: boolean;
    key: string;
    isInfiniteKey: boolean;
};

declare const decode: (key: Key) => DecodedSWRKey | null;

declare const encode: <Result>(parser: PostgrestParser<Result>, isInfinite: boolean) => string;

declare const middleware: Middleware;
declare const infiniteMiddleware: <Result>(useSWRInfiniteNext: SWRInfiniteHook) => (keyFn: SWRInfiniteKeyLoader, fetcher: SWRInfiniteFetcher, config: SWRInfiniteConfiguration) => swr_infinite.SWRInfiniteResponse<any, any>;

declare const usePostgrestFilterCache: <R extends Record<string, unknown>>() => (query: string, opts?: PostgrestQueryParserOptions) => PostgrestFilter<any>;

declare const useQueriesForTableLoader: (table: string) => () => {
    paths: _supabase_cache_helpers_postgrest_filter.Path[];
    filters: _supabase_cache_helpers_postgrest_filter.FilterDefinitions;
}[];

type Operation = 'Insert' | 'UpdateOne' | 'Upsert' | 'DeleteOne';
type GetInputType<T extends GenericTable, O extends Operation> = O extends 'DeleteOne' ? Partial<T['Row']> : O extends 'Insert' | 'Upsert' ? T['Insert'][] : O extends 'UpdateOne' ? T['Update'] : never;
type GetReturnType<S extends GenericSchema, T extends GenericTable, O extends Operation, Q extends string = '*', R = GetResult<S, T['Row'], Q extends '*' ? '*' : Q>> = O extends 'UpdateOne' ? R | null : O extends 'DeleteOne' ? R | null : O extends 'Insert' | 'Upsert' ? R[] | null : never;
type UsePostgrestSWRMutationOpts<S extends GenericSchema, T extends GenericTable, O extends Operation, Q extends string = '*', R = GetResult<S, T['Row'], Q extends '*' ? '*' : Q>> = PostgrestMutatorOpts<T['Row']> & Pick<MutatorOptions, 'throwOnError' | 'revalidate'> & SWRMutationConfiguration<GetReturnType<S, T, O, Q, R>, PostgrestError, GetInputType<T, O>, string> & {
    disableAutoQuery?: boolean;
};

declare function useDeleteMutation<S extends GenericSchema, T extends GenericTable, Q extends string = '*', R = GetResult<S, T['Row'], Q extends '*' ? '*' : Q>>(qb: PostgrestQueryBuilder<S, T>, primaryKeys: (keyof T['Row'])[], query?: (Q extends '*' ? "'*' is not allowed" : Q) | null, opts?: UsePostgrestSWRMutationOpts<S, T, 'DeleteOne', Q, R>): SWRMutationResponse<R | null, PostgrestError$1, Partial<T['Row']>>;

declare function useInsertMutation<S extends GenericSchema, T extends GenericTable, Q extends string = '*', R = GetResult<S, T['Row'], Q extends '*' ? '*' : Q>>(qb: PostgrestQueryBuilder<S, T>, primaryKeys: (keyof T['Row'])[], query?: (Q extends '*' ? "'*' is not allowed" : Q) | null, opts?: UsePostgrestSWRMutationOpts<S, T, 'Insert', Q, R>): SWRMutationResponse<R[] | null, PostgrestError$1, T['Insert'][]>;

declare function useUpdateMutation<S extends GenericSchema, T extends GenericTable, Q extends string = '*', R = GetResult<S, T['Row'], Q extends '*' ? '*' : Q>>(qb: PostgrestQueryBuilder<S, T>, primaryKeys: (keyof T['Row'])[], query?: (Q extends '*' ? "'*' is not allowed" : Q) | null, opts?: UsePostgrestSWRMutationOpts<S, T, 'UpdateOne', Q, R>): SWRMutationResponse<R | null, PostgrestError$1, T['Update']>;

declare function useUpsertMutation<S extends GenericSchema, T extends GenericTable, Q extends string = '*', R = GetResult<S, T['Row'], Q extends '*' ? '*' : Q>>(qb: PostgrestQueryBuilder<S, T>, primaryKeys: (keyof T['Row'])[], query?: (Q extends '*' ? "'*' is not allowed" : Q) | null, opts?: UsePostgrestSWRMutationOpts<S, T, 'Upsert', Q, R>): SWRMutationResponse<R[] | null, PostgrestError$1, T['Insert'][], string>;

type UseInfiniteQueryReturn<Result extends Record<string, unknown>> = SWRInfiniteResponse<Exclude<PostgrestResponse<Result>['data'], null>, PostgrestError$1>;
declare function useInfiniteQuery<Schema extends GenericSchema, Table extends Record<string, unknown>, Result extends Record<string, unknown>>(query: PostgrestTransformBuilder<Schema, Table, Result[]> | null, config?: SWRInfiniteConfiguration & {
    pageSize?: number;
}): UseInfiniteQueryReturn<Result>;

type SWRInfiniteScrollPostgrestResponse<Result> = Omit<SWRInfiniteResponse<PostgrestHasMorePaginationCacheData<Result>, PostgrestError$1>, 'data'> & {
    loadMore: null | (() => void);
    data: Result[] | undefined;
};
type UseInfiniteScrollQueryReturn<Result extends Record<string, unknown>> = Omit<SWRInfiniteResponse<PostgrestHasMorePaginationResponse<Result>, PostgrestError$1>, 'data'> & {
    loadMore: null | (() => void);
    data: Result[] | undefined;
};
declare function useInfiniteScrollQuery<Schema extends GenericSchema, Table extends Record<string, unknown>, Result extends Record<string, unknown>>(query: PostgrestTransformBuilder<Schema, Table, Result[]> | null, config?: SWRInfiniteConfiguration & {
    pageSize?: number;
}): UseInfiniteScrollQueryReturn<Result>;

type SWRInfinitePaginationPostgrestResponse<Result> = Omit<SWRInfiniteResponse<PostgrestHasMorePaginationResponse<Result>, PostgrestError$1>, 'data' | 'size' | 'setSize'> & {
    pages: SWRInfiniteResponse<Result[], PostgrestError$1>['data'];
    currentPage: null | Result[];
    pageIndex: number;
    setPage: (idx: number) => void;
    nextPage: null | (() => void);
    previousPage: null | (() => void);
};
type UsePaginationQueryReturn<Result extends Record<string, unknown>> = SWRInfinitePaginationPostgrestResponse<Result>;
declare function usePaginationQuery<Schema extends GenericSchema, Table extends Record<string, unknown>, Result extends Record<string, unknown>>(query: PostgrestTransformBuilder<Schema, Table, Result[]> | null, config?: SWRInfiniteConfiguration & {
    pageSize?: number;
}): UsePaginationQueryReturn<Result>;

type UseQuerySingleReturn<Result> = Omit<SWRResponse<PostgrestSingleResponse<Result>['data'], PostgrestError$1>, 'mutate'> & Pick<SWRResponse<PostgrestSingleResponse<Result>, PostgrestError$1>, 'mutate'> & Pick<PostgrestSingleResponse<Result>, 'count'>;
type UseQueryMaybeSingleReturn<Result> = Omit<SWRResponse<PostgrestMaybeSingleResponse<Result>['data'], PostgrestError$1>, 'mutate'> & Pick<SWRResponse<PostgrestMaybeSingleResponse<Result>, PostgrestError$1>, 'mutate'> & Pick<PostgrestMaybeSingleResponse<Result>, 'count'>;
type UseQueryReturn<Result> = Omit<SWRResponse<PostgrestResponse<Result>['data'], PostgrestError$1>, 'mutate'> & Pick<SWRResponse<PostgrestResponse<Result>, PostgrestError$1>, 'mutate'> & Pick<PostgrestResponse<Result>, 'count'>;
type UseQueryAnyReturn<Result> = Omit<SWRResponse<AnyPostgrestResponse<Result>['data'], PostgrestError$1>, 'mutate'> & Pick<SWRResponse<AnyPostgrestResponse<Result>, PostgrestError$1>, 'mutate'> & Pick<AnyPostgrestResponse<Result>, 'count'>;
/**
 * Perform a postgrest query
 * @param query
 * @param config
 */
declare function useQuery<Result>(query: PromiseLike<PostgrestSingleResponse<Result>> | null, config?: SWRConfiguration): UseQuerySingleReturn<Result>;
declare function useQuery<Result>(query: PromiseLike<PostgrestMaybeSingleResponse<Result>> | null, config?: SWRConfiguration): UseQueryMaybeSingleReturn<Result>;
declare function useQuery<Result>(query: PromiseLike<PostgrestResponse<Result>> | null, config?: SWRConfiguration): UseQueryReturn<Result>;

type UseSubscriptionQueryOpts<S extends GenericSchema, T extends GenericTable, Q extends string = '*', R = GetResult<S, T['Row'], Q extends '*' ? '*' : Q>> = PostgrestMutatorOpts<T['Row']> & MutatorOptions & {
    callback?: (event: RealtimePostgresChangesPayload<T['Row']> & {
        data: T['Row'] | R;
    }) => void | Promise<void>;
};
declare function useSubscriptionQuery<S extends GenericSchema, T extends GenericTable, Q extends string = '*', R = GetResult<S, T['Row'], Q extends '*' ? '*' : Q>>(client: SupabaseClient | null, channelName: string, filter: Omit<RealtimePostgresChangesFilter<`${REALTIME_POSTGRES_CHANGES_LISTEN_EVENT.ALL}`>, 'table'> & {
    table: string;
}, primaryKeys: (keyof T['Row'])[], query?: Q extends '*' ? "'*' is not allowed" : Q | null, opts?: UseSubscriptionQueryOpts<S, T, Q, R>): {
    channel: RealtimeChannel | undefined;
    status: string | undefined;
};

type UseSubscriptionOpts<T extends GenericTable> = PostgrestMutatorOpts<T['Row']> & MutatorOptions & {
    callback?: (event: RealtimePostgresChangesPayload<T['Row']>) => void | Promise<void>;
};
declare function useSubscription<T extends GenericTable>(channel: RealtimeChannel | null, filter: Omit<RealtimePostgresChangesFilter<`${REALTIME_POSTGRES_CHANGES_LISTEN_EVENT.ALL}`>, 'table'> & {
    table: string;
}, primaryKeys: (keyof T['Row'])[], opts?: UseSubscriptionOpts<T>): {
    status: string | undefined;
};

export { DecodedSWRKey, GetInputType, GetReturnType, INFINITE_KEY_PREFIX, INFINITE_PREFIX, KEY_PREFIX, KEY_SEPARATOR, Operation, POSTGREST_FILTER_KEY_PREFIX, SWRInfinitePaginationPostgrestResponse, SWRInfiniteScrollPostgrestResponse, UseInfiniteQueryReturn, UseInfiniteScrollQueryReturn, UsePaginationQueryReturn, UsePostgrestSWRMutationOpts, UseQueryAnyReturn, UseSubscriptionOpts, UseSubscriptionQueryOpts, createKeyGetter, decode, encode, infiniteMiddleware, middleware, useDeleteItem, useDeleteMutation, useInfiniteQuery, useInfiniteScrollQuery, useInsertMutation, usePaginationQuery, usePostgrestFilterCache, useQueriesForTableLoader, useQuery, useSubscription, useSubscriptionQuery, useUpdateMutation, useUpsertItem, useUpsertMutation };
